'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class; /**
             * Created by tonyjiang on 16/3/14.
             */


var _interface = require('../interface');

var _interface2 = _interopRequireDefault(_interface);

var _chanjetPluginBase = require('chanjet-plugin-base');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TakePhotoPluginChanjet = (0, _chanjetPluginBase.ChanjetDecorator)(_class = function (_TakePhotoPlugin) {
    _inherits(TakePhotoPluginChanjet, _TakePhotoPlugin);

    function TakePhotoPluginChanjet() {
        _classCallCheck(this, TakePhotoPluginChanjet);

        var _this = _possibleConstructorReturn(this, (TakePhotoPluginChanjet.__proto__ || Object.getPrototypeOf(TakePhotoPluginChanjet)).call(this));

        _this._defaultTakePhotoOptions = {
            "quality": 0
        };
        var _mutants$env$constant = mutants.env.constant.os;
        var ios = _mutants$env$constant.ios;
        var android = _mutants$env$constant.android;


        _this.pluginName = {};
        _this.pluginName[ios] = 'Camera';
        _this.pluginName[android] = 'CameraPlugin';

        _this.methodName = {};
        _this.methodName[ios] = {
            takePhoto: 'takePhotoNoUpload'
        };
        _this.methodName[android] = {
            takePhoto: 'takePhoto'
        };

        return _this;
    }

    _createClass(TakePhotoPluginChanjet, [{
        key: 'takePhoto',


        /**
         *
         * @param options
         *      @property options.quality 0:高质量(默认) , 1:中等质量 , 2:低质量
         * @param callback 执行完成后回调
         * @param requestId 应用自己分配的值,用于在restore时判断数据来源进行后续操作.
         *
         */
        value: function takePhoto(options, callback) {
            var requestId = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

            Object.assign(options, this._defaultTakePhotoOptions, options);

            var os = mutants.env.os;


            var pluginName = this.pluginName[os];
            var methodName = this.methodName[os].takePhoto;

            cordova.exec(this._takePhotoSuccess.bind(this, callback, requestId), this._takePhotoFailed.bind(this, callback, requestId), pluginName, methodName, [options, requestId]);
        }
    }, {
        key: '_takePhotoSuccess',
        value: function _takePhotoSuccess(callback, requestId, data) {
            var os = mutants.env.os;
            var _mutants$env$constant2 = mutants.env.constant.os;
            var android = _mutants$env$constant2.android;
            var ios = _mutants$env$constant2.ios;
            //如果是安卓

            if (os == android) {
                var result = {
                    resultCode: data.result,
                    message: data.message,
                    requestId: requestId,
                    body: {
                        data: data.urls
                    }
                };
                callback(result);
            } else {
                //如果是ios
                var rsJSON = JSON.parse(data);

                var resultCode = rsJSON.code == 0 ? 0 : 1;
                var message = rsJSON.code == 0 ? rsJSON.msg : JSON.parse(rsJSON.msg);
                var _result = {
                    resultCode: resultCode,
                    message: message,
                    requestId: requestId,
                    body: {
                        data: [rsJSON.data.nativeUrl]
                    }
                };

                callback(_result);
            }
        }
    }, {
        key: '_takePhotoFailed',
        value: function _takePhotoFailed(callback, requestId, error) {
            var rs = {
                resultCode: 1,
                message: error,
                requestId: requestId,
                body: {}
            };
            callback(rs);
        }
    }]);

    return TakePhotoPluginChanjet;
}(_interface2.default)) || _class;

exports.default = TakePhotoPluginChanjet;