/**
 * Created by tonyjiang on 16/3/14.
 */
import TakePhotoPlugin from '../interface'
import {MockDecorator} from 'chanjet-plugin-base'

/**
 * 短信插件mock实现类
 * @extends PluginMock,SMSPlugin
 */
@MockDecorator
class TakePhotoPluginMock extends TakePhotoPlugin{

    /**
     * @member mockData {JSONObject} mock数据
     * @example
     *  success
     *  mockData = {
     *      status : 'success',
     *      data : ['http://www.example.com/1.png']
     *  }
     *
     *  failed
     *  mockData = {
     *      status : 'failed',
     *      message : '调用插件失败'
     *  }
     *
     *  cancel
     *  mockData = {
     *      status : 'cancel'
     *  }
     *
     *
     */

    takePhoto(options , callback = () => {} , requestId = ''){
        let resultCode = 0 , message = '' , body = {};
        if(this.mockData.status == 'success'){
            resultCode = 0;
            body.data = this.mockData.data;
        }else if(this.mockData.status == 'failed'){
            resultCode = 1;
            message = this.mockData.message;
        }else if(this.mockData.status == 'cancel'){
            resultCode = 2;
        }


        const rs = {
            resultCode : resultCode,
            message : message,
            requestId : requestId,
            body : body
        };

        callback(rs);
    }
}

export default TakePhotoPluginMock