/**
 * Created by TonyJiang on 16/4/17.
 */
import PluginTestUtil from 'chanjet-plugin-base/dist/PluginTestUtil';
import TakePhotoPlugin from '../src/chanjet'

global.mutants = {
    env : {
        os : 'ios',
        constant : {
            os : {
                ios : 'ios',
                android : 'android'
            }
        }
    }
};

const pluginName = {
    ios : 'Camera',
    android : 'CameraPlugin'
};

const methodName = {
    ios : 'takePhotoNoUpload',
    android : 'takePhoto'
};

const instance = new TakePhotoPlugin();
const testUtil = new PluginTestUtil();
testUtil.init(cordova);


describe('TakePhotoPluginChanjet 单元测试' , () => {

    describe('ios环境下通用测试' , () => {
        mutants.env.os = mutants.env.constant.os.ios;
        //ios环境, 通用测试
        testUtil.commonTest({
            funcName : 'takePhoto',
            func : instance.takePhoto.bind(instance),
            pluginName : pluginName[mutants.env.os],
            methodName : methodName[mutants.env.os],
            validateParams : ['quality'],
            params : {}
        });
    });


    describe('android环境下通用测试' , () => {
        mutants.env.os = mutants.env.constant.os.android;
        //android环境, 通用测试
        testUtil.commonTest({
            funcName : 'takePhoto',
            func : instance.takePhoto.bind(instance),
            pluginName : pluginName[mutants.env.os],
            methodName : methodName[mutants.env.os],
            validateParams : ['quality'],
            params : {}
        });
    });


});